package gov.anl.dm.esafsync;

import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

public class PsqlConnection {
	public final class UserInfo {
		private final String signature;
		private final int id;
		
		UserInfo(String signature, int id) {
			this.signature = signature;
			this.id = id;
		}
		String getSignature() {
			return signature;
		}

		int getId() {
			return id;
		}
	}

	final int ADMIN_ROLE_ID = 1;
    Connection connection = null;

    public void connect(Properties config) throws SQLException, ClassNotFoundException {
            Class.forName("org.postgresql.Driver");
            connection = DriverManager.getConnection(
                    config.getProperty("dm.database.connection"),
                    config.getProperty("dm.database.username"),
                    config.getProperty("dm.database.password"));
    }
    
    UserInfo getUserInfo(String user) throws SQLException {
    	String signature = null;
    	int id = -1;
    	Statement statement = connection.createStatement();
    	if (statement != null) {
    		ResultSet results = statement.executeQuery("SELECT * FROM user_info WHERE username = '" + user + "';");
    		if (results != null) {
    			while (results.next()) {
    				signature = results.getString("password");
    				if (signature.length() > 0) {
    					id = Integer.parseInt(results.getString("id"));
    					break;
    				}
    			}
        		results.close();
    		}
    		statement.close();
    	}
    	if (id < 0) {
    		return null;
    	} else {
    		return new UserInfo(signature, id);
    	}
    }

    boolean isAuthorized(int id) throws SQLException {
    	boolean isAuthorized = false;
    	Statement statement = connection.createStatement();
    	if (statement != null) {
    		ResultSet results = statement.executeQuery("SELECT * FROM user_system_role WHERE user_id = " + id + ";");
    		if (results != null) {
    			while (results.next()) {
    				int roleId = Integer.parseInt(results.getString("role_type_id"));
    				if (roleId == ADMIN_ROLE_ID) {
    					isAuthorized = true;
    					break;
    				}
    			}
        		results.close();
    		}
    		statement.close();
    	}
		return isAuthorized;    	
    }
    
    void close() {
        try {
            connection.close();
        } catch (SQLException ex) {
            // nothing to do here
        }
    }
}
